#version 150

#moj_import <fog.glsl>

uniform sampler2D Sampler0;
uniform sampler2D Sampler1;

uniform vec4 ColorModulator;
uniform float FogStart;
uniform float FogEnd;
uniform vec4 FogColor;

in float vertexDistance;
in vec4 vertexColor;
in vec2 texCoord0;
in vec2 texCoord1;
in vec4 normal;

out vec4 fragColor;

void main() {
    vec4 color = texture(Sampler0, texCoord0);
    int a = int(color.a * 255);
    if (color.a < 0.1) {
        discard;
    } else if (a <= 254 && a >= 253) {
        color.a = 1.0;
        fragColor = linear_fog(color, vertexDistance, FogStart, FogEnd, FogColor);
    } else if (a == 252) {
        color.a = 1.0;
        fragColor = linear_fog(color*mix(color, vertexColor, .25), vertexDistance, FogStart, FogEnd, FogColor);
    } else {
        fragColor = linear_fog(color * vertexColor * ColorModulator, vertexDistance, FogStart, FogEnd, FogColor);
    }
}