#version 150

#moj_import <light.glsl>

in vec3 Position;
in vec4 Color;
in vec2 UV0;
in vec2 UV1;
in ivec2 UV2;
in vec3 Normal;

uniform sampler2D Sampler2;

uniform mat4 ModelViewMat;
uniform mat4 ProjMat;
uniform mat3 IViewRotMat;
uniform vec3 ChunkOffset;

uniform vec3 Light0_Direction;
uniform vec3 Light1_Direction;

uniform float GameTime;

out float vertexDistance;
out vec4 vertexColor;
out vec2 texCoord0;
out vec2 texCoord1;
out vec2 texCoord2;
out vec4 normal;

#moj_import <nlz_utils.glsl>

void main() {
    float t = 2 * PI * GameTime;
    vec3 position = Position+ChunkOffset;
    

    if ((Color.r+Color.g+Color.b)*255 == 1) {
        position += vec3(rand(t)*2., rand(t+1)*1., rand(t+2)*1.)*0.01;
    }



    gl_Position = ProjMat * ModelViewMat * vec4(position, 1.0);

    vertexDistance = length((ModelViewMat * vec4(position, 1.0)).xyz);
    vertexColor = minecraft_mix_light(Light0_Direction, Light1_Direction, Normal, Color) * texelFetch(Sampler2, UV2 / 16, 0);
    texCoord0 = UV0;
    texCoord1 = UV1;
    texCoord2 = UV2;
    normal = ProjMat * ModelViewMat * vec4(Normal, 0.0);
}